const
   maxn = 100000;

   infile = '';
   outfile = '';

type
   tnum = record
      v   : longint;
      ind : longint;
   end;

var
   f: text;


   res, sub, bo, bp, o, p, z, i, j, n, min : longint;

   num : array[1..maxn] of tnum;
   pol, otr : array[1..maxn] of longint;

procedure input;
begin
   assign(f, infile);
   reset(f);
   readln(f, n);
   for i:=1 to n do
      begin
         read(f, j);
         num[i].v:=j;
         num[i].ind:=i;
      end;
   close(f);
end;

var y : tnum;

procedure sort(l,r: longint);
var
   i,j,x: longint;
begin
   i:=l;
   j:=r;
   x:=num[(l+r) div 2].v;
   repeat
     while num[i].v>x do inc(i);
     while x>num[j].v do dec(j);
     if not(i>j) then
       begin
          y:=num[i];
          num[i]:=num[j];
          num[j]:=y;
          inc(i); dec(j);
       end;
   until i>j;
   if l<j then sort(l,j);
   if i<r then sort(i,r);
end;

procedure sort1(l,r: longint);
var
   i,j,x: longint;
begin
   i:=l;
   j:=r;
   x:=otr[(l+r) div 2];
   repeat
     while otr[i]>x do inc(i);
     while x>otr[j] do dec(j);
     if not(i>j) then
       begin
          y.v:=otr[i];
          otr[i]:=otr[j];
          otr[j]:=y.v;
          inc(i); dec(j);
       end;
   until i>j;
   if l<j then sort1(l,j);
   if i<r then sort1(i,r);
end;

procedure sort2(l,r: longint);
var
   i,j,x: longint;
begin
   i:=l;
   j:=r;
   x:=pol[(l+r) div 2];
   repeat
     while pol[i]<x do inc(i);
     while x<pol[j] do dec(j);
     if not(i>j) then
       begin
          y.v:=pol[i];
          pol[i]:=pol[j];
          pol[j]:=y.v;
          inc(i); dec(j);
       end;
   until i>j;
   if l<j then sort2(l,j);
   if i<r then sort2(i,r);
end;



procedure solve;
begin
   sort(1, n);
   for i:=1 to n do
      begin
         j:=num[n].v+n-i-num[i].v;
         if j>0 then begin inc(p); pol[p]:=j; end
         else if j<0 then begin inc(o); otr[o]:=j; end
         else inc(z);
      end;
   if o>1 then sort1(1, o);
   if p>1 then sort2(1, p);
   if o<p then
      begin
         i:=0; j:=1;
         while p>o do
            begin
               bp:=p; bo:=o;
               {while otr[i]=otr[i+1] do inc(i);}
               while pol[j]=pol[j+1] do inc(j);
               p:=p-(j-i);
               o:=o+z;
               z:=j-i;
               if abs(p-o)<abs(bp-bo) then sub:=-pol[j];
               i:=j; inc(j);
            end;
      end
   else if o>p then
      begin
         i:=1; j:=0;
         while p<o do
            begin
               bp:=p; bo:=o;
               while otr[i]=otr[i+1] do inc(i);
               {while pol[j]=pol[j+1] do inc(j);}
               o:=o-(i-j);
               p:=p+z;
               z:=(i-j);
               {sub:=-otr[i];}
               if abs(p-o)<abs(bp-bo) then sub:=-otr[i];
               j:=i; inc(i);
            end;
      end;
   for i:=1 to n do
      begin
         res:=res+abs((num[n].v+n-i-num[i].v)+sub);
         pol[num[i].ind]:=((num[n].v+n-i-num[i].v)+sub);
      end;
end;

procedure output;
begin
   assign(f, outfile);
   rewrite(f);
   writeln(f, res);
   for i:=1 to n do write(pol[i],' ');
   writeln(f);
   close(f);
end;

begin
   input;
   solve;
   output;
end.
