type
   tnum = record x, pos : longint; end;
var
   a, b : array[1..1000000] of tnum;
   n : longint;
   t : tnum;

procedure qsort(l, r : longint);
var i, j, x : longint;
begin
   i:=l; j:=r; x:=a[(l+r) shr 1].x;
   repeat
      while a[i].x < x do inc(i);
      while a[j].x > x do dec(j);
      if i <= j then
      begin
         t:=a[i]; a[i]:=a[j]; a[j]:=t;
         inc(i); dec(j);
      end;
   until i > j;
   if l < j then qsort(l, j);
   if i < r then qsort(i, r);
end;

var
   i : longint;
   c : array[1..1000000] of longint;
   avg, pos, res : longint;
begin
   readln(n);
   for i:=1 to n do
   begin
      read(a[i].x);
      a[i].pos:=i;
   end;

   b:=a;
   qsort(1, n);
   pos:=n div 2 + 1;
   avg:=a[pos].x;

   res:=0;
   for i:=1 to n do
   begin
      a[i].x:=i+avg-pos-a[i].x;
      inc(res, abs(a[i].x));
   end;
   for i:=1 to n do
   begin
      c[a[i].pos]:=a[i].x;
   end;

   writeln(res);
   for i:=1 to n do write(c[i], ' ');
end.
