const
   maxn = 20000; maxm = 200000;
type
   pnode = ^tnode;
   tnode = record child, bus, t0, dt : longint; next : pnode; end;
   ttt = record t, v : longint; end;

var
   heap : array[1..maxn] of ttt;
   hn : longint;

PROCEDURE SWAP(I, J : LONGINT);
VAR T : TTT;
BEGIN
   T:=HEAP[I];
   HEAP[I]:=HEAP[J];
   HEAP[J]:=T;
END;

function pop : longint;
VAR CUR, C : LONGINT;
begin
   POP:=HEAP[1].V;
   SWAP(1, HN);
   DEC(HN);
   CUR:=1;
   WHILE TRUE DO
   BEGIN
      C:=CUR * 2;
      IF C > HN THEN BREAK;

      IF C < HN THEN
         IF HEAP[C+1].T < HEAP[C].T THEN INC(C);

      IF HEAP[C].T < HEAP[CUR].T THEN SWAP(C, CUR)
      ELSE BREAK;

      CUR:=C;
   END;
end;

PROCEDURE push(T, V : LONGINT);
VAR
   P, C: LONGINT;
BEGIN
   INC(HN);
   HEAP[HN].T:=T;
   HEAP[HN].V:=V;
   C:=HN;
   WHILE C > 1 DO
   BEGIN
      P:=C DIV 2;
      IF HEAP[P].T > HEAP[C].T THEN SWAP(P, C)
      ELSE BREAK;
      C:=P;
   END;
END;

var
   a : array[1..maxn] of pnode;
   b : array[1..maxn] of record parent, bus, t : longint; end;
   u : array[1..maxn] of boolean;
   c : array[1..maxm] of longint;
   n, m, i : longint;
   p : pnode;
   v : longint;
   min : longint;
   nbus : longint;
begin
   readln(n, m);
   for i:=1 to m do
   begin
      new(p);
      readln(v, p^.child, p^.t0, p^.dt);
      p^.bus:=i;
      p^.next:=a[v];
      a[v]:=p;
   end;

   for i:=2 to n do b[i].t:=9999999;
   fillchar(u, sizeof(u), false);

   v:=1;
   while v <> n do
   begin
      u[v]:=true;
      p:=a[v];
      while p <> nil do IF NOT U[P^.CHILD] THEN
      begin
         if p^.t0 >= b[v].t then
            if p^.t0 + p^.dt < b[p^.child].t then
            begin
               b[p^.child].t:=p^.t0 + p^.dt;
               b[p^.child].bus:=p^.bus;
               b[p^.child].parent:=v;
               PUSH(b[p^.child].t, P^.CHILD);
            end;
         p:=p^.next;
      end;

      REPEAT
         V:=POP;
      UNTIL NOT U[V];
{      min:=999999;
      for i:=1 to n do
         if not u[i] then
            if b[i].t < min then begin min:=b[i].t; v:=i; end;}
   end;

   nbus:=0;
   while v <> 1 do
   begin
      inc(nbus);
      c[nbus]:=b[v].bus;
      v:=b[v].parent;
   end;

   writeln(b[n].t);
   writeln(nbus);
   for i:=nbus downto 1 do
      writeln(c[i]);
end.
